@import "../mixins/shapes";

// BEGIN: Declaration
$ball_shadow: 30px 0 0;
$ball_color--red: #cb2025;
$ball_color--yellow: #f8b334;
$ball_color--green: #97bf0d;
$ball_color--sky_blue: #00a096;
$color--black: #000;

$animation_duration: 1s;
// END: Declaration

// BEGIN: SCREEN
%screen--full_size {
  width: 100%;
  height: 100%;
}

%element--absolute_center {
  position: fixed;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  margin: auto;
}

.is-loading {
  overflow: hidden;
}

.loader {
  // position: relative
  @extend %screen--full_size;
  @extend %element--absolute_center;
  display: flex;
  z-index: 9;

  &__backdrop {
    @extend %screen--full_size;
    position: relative;
    background: $color--black;
    opacity: 0.8;
    z-index: 998;
  }

  &__spinner {
    @include square($size: 48px);
    @extend %element--absolute_center;
    position: inherit;
    // left: calc(50% - 48px);
    // top: calc(50% - 48px);
    border: 5px solid $ball_color--sky_blue;
    box-sizing: border-box;
    animation: rotation 1.75s linear infinite;
    z-index: 999;
  }

  &__spinner::after,
  &__spinner::before {
    content: '';
    box-sizing: border-box;
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    bottom: 0;
    margin: auto;
    border: 3px solid $ball_color--yellow;
    @include square($size: 38);
    animation: rotationBack 1.25s linear infinite;
    transform-origin: center center;
  }

  &__spinner::before {
    @include square($size: 28);
    border-color: #FFF;
    box-sizing: border-box;
    animation: rotationWithBeat 1.25s linear infinite;
    border-color: $ball_color--red;
    border-width: 4px;
  }

  @keyframes rotation {
    0% {
      transform: rotate(0deg);
    }
    100% {
      transform: rotate(360deg);
    }
  }

  @keyframes rotationBack {
    0% {
      transform: rotate(0deg);
    }
    100% {
      transform: rotate(-360deg);
    }
  }

  @keyframes rotationWithBeat {
    0% {
      transform: rotate(0deg);
      @include square($size: 28px);
    }
    75% {
      transform: rotate(360deg);
      @include square($size: 10px);
    }
    100% {
      transform: rotate(0deg);
      @include square($size: 28px);
    }
  }
}

body > .loader {
  z-index: 3000;
}
